elnombrequetuquieras/routes/web.php
<?php

use App\Http\Controllers\ClientController;
use App\Http\Controllers\InvoiceController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\RankingController;
use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');

});


Route::get('/products', [ProductController::class, 'products'])->name('products');

Route::get('/products/{product}/delete', [ProductController::class, 'delete']);

Route::get('/products/inserts', function (){
    return view('inserts');
})->name('inserts');


Route::post('/products', [ProductController::class, 'store'])->name('store');

Route::get('/rankings', [RankingController::class, 'showForm'])->name('tops.form');
Route::post('/rankings', [RankingController::class, 'showTop'])->name('tops.show');

Route::get('/clients', [ClientController::class, 'clients'])->name('clients');

Route::get('/clients/{client}/delete', [ClientController::class, 'delete']);

Route::get('/clients/inserts', function (){
    return view('clientinserts');
})->name('clientinserts');

Route::post('/clients', [ClientController::class, 'store'])->name('store');




Route::get('/invoices/list', [InvoiceController::class, 'invoices'])->name('invoices.list');
Route::post('/invoices', [InvoiceController::class, 'store'])->name('invoices.store');

Route::get('/invoices/{invoice}/delete', [InvoiceController::class, 'delete']);
Route::get('/invoices/inserts', [InvoiceController::class, 'passarclients'])->name('invoices.inserts');

Route::post('/invoices/insert/confirm', [InvoiceController::class, 'confirm'])->name('invoices.confirm');

Route::get('/products/{id}/restore', [ProductController::class, 'restore'])->name('products.restore');

require __DIR__.'/auth.php';

elnombrequetuquieras/app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;
use Illuminate\View\View;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     */
    public function render(): View
    {
        return view('layouts.app');
    }
}

elnombrequetuquieras/resources/views/Pikachu.blade.php
<h1>
     Always remember that you are absolutely unique. Just like everyone else. - Margaret Mead
</h1>

elnombrequetuquieras/resources/views/clientinserts.blade.php
<div>
    <!-- Simplicity is the essence of happiness. - Cedric Bledsoe -->
</div>
<x-app-layout>
    <div>
        <a href="{{ route('clients') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Clients</a>
        <a href="{{ route('products') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Productes</a>
        <a href="{{ route('tops.form') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Rànkings</a>

        <h1 style="font-size: 2rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">Emplena el formulari amb els teus detalls</h1>

    </div>

    <div style="display: flex;
            justify-content: center;">
    <form method="POST" action="{{ route('clients') }}">
        @csrf
        <div>
            <label for="client_name">Nombre del Cliente:</label>
            <input type="text" id="client_name" name="client_name" required>
        </div><br>
        <div>
            <label for="race">Raza:</label>
            <select id="race" name="race" required>
                <option value="human">Human</option>
                <option value="saiyan">Saiyan</option>
                <option value="giant">Giant</option>
                <option value="fairy">Fairy</option>
                <option value="monster">Monster</option>
                <option value="elf">Elf</option>
                <option value="dwarf">Dwarf</option>
                <option value="werewolf">Werewolf</option>
                <option value="mermaid">Mermaid</option>
                <option value="gnome">Gnome</option>
                <option value="robot">Robot</option>
                <option value="centaur">Centaur</option>
            </select>
        </div><br>
        <div>
            <label for="level">Nivel:</label>
            <input type="number" id="level" name="level" required>
        </div><br>

        <div>
            <label for="current_money">Dinero actual:</label>
            <input type="number" id="current_money" name="current_money" required>
        </div><br>
        <div>
            <label for="description">Descripción:</label>
            <textarea id="description" name="description" required></textarea>
        </div><br>
        <div>
            <label for="password">Password:</label>
            <textarea id="password" name="password" required></textarea>
        </div><br>
        <div>
            <button type="submit">Insertar Cliente</button>
        </div><br>
    </form>
    </div>

    <div style="text-align: center;">
        <h1 style="font-size: 1rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">Ja ets client? Ves a la pantalla de compra des d'aquí mateix!</h1>
        <a href="{{ route('invoices.inserts') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white;  padding: 1rem; border-radius: 0.25rem; display: inline-block">Comprar</a>

    </div>
</x-app-layout>

elnombrequetuquieras/resources/views/clientsview.blade.php
<div>
    <!-- The best way to take care of the future is to take care of the present moment. - Thich Nhat Hanh -->
</div>

<x-app-layout>
    <div>

        <a href="{{ route('products') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Productos</a>
        <a href="{{ route('invoices.inserts') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Comprar</a>
        <h1 style="font-size: 3rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">CLIENTS</h1>
    </div>
    <div style="display: flex;
            justify-content: center;">
    <table>
        <thead>
        <tr>
            <th>id</th>
            <th>name</th>
            <th>race</th>
            <th>level</th>
            <th>current_money</th>
            <th>description</th>
            <th>purchases</th>
        </tr>
        </thead>

        <body>
        @foreach($clients as $cli)
            <tr>
                <td>{{$cli->id}}</td>
                <td>{{$cli->client_name}}</td>
                <td>{{$cli->race}}</td>
                <td>{{$cli->level}}</td>
                <td>{{$cli->current_money}}</td>
                <td>{{$cli->description}}</td>
                <td>{{$cli->purchases}}</td>
                <td><button type="submit" onclick="location.href='{{url(('/clients/'.$cli->id.'/delete/'))}}'">Delete</button></td>
            </tr>



        @endforeach



        </body>
    </table>
    </div>
    <div style="text-align: center;">
        <a href="{{ route('clientinserts') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white; padding: 1rem; border-radius: 0.25rem; display: inline-block">Insertar Cliente</a>

    </div>
</x-app-layout>

elnombrequetuquieras/resources/views/dashboard.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Dashboard') }}
        </h2>
    </x-slot>

    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="p-6 text-gray-900">
                    {{ __("You're logged in!") }}
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

elnombrequetuquieras/resources/views/inserts.blade.php
<div>
    <!-- Smile, breathe, and go slowly. - Thich Nhat Hanh -->
</div>

<!-- resources/views/inserts.blade.php -->
<x-app-layout>
    <div>
        <a href="{{ route('products') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Productes</a>

        <h1 style="font-size: 2rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">Emplena el formulari amb els detalls del nou producte</h1>
    </div>
    <div style="display: flex;
            justify-content: center;">
    <form method="POST" action="{{ route('products') }}">
        @csrf
        <div>
            <label for="product_name">Nombre del Producto:</label>
            <input type="text" id="product_name" name="product_name" required>
        </div>
        <br>
        <div>
            <label for="product_type">Tipo de Producto:</label>

            <select id="product_type" name="product_type">
                <option value="Weapon">Weapon</option>
                <option value="Armour">Armour</option>
                <option value="Shield">Shield</option>
                <option value="Potion">Potion</option>
                <option value="Projectile">Projectile</option>
                <option value="Consumable">Consumable</option>
            </select>
        </div>
        <br>
        <div>
            <label for="price">Precio:</label>
            <input type="number" id="price" name="price" required>
        </div><br>
        <div>
            <label for="description">Descripción:</label>
            <textarea id="description" name="description" required></textarea>
        </div><br>
        <div>
            <label for="level">Nivel:</label>
            <input type="number" id="level" name="level" required>
        </div><br>
        <div>
            <label for="level_required">Nivel Requerido:</label>
            <input type="number" id="level_required" name="level_required" required>
        </div><br>


        <div>
            <button type="submit">Insertar Producto</button>
        </div>
    </form>
    </div>
    <div>



    </div>
</x-app-layout>

elnombrequetuquieras/resources/views/invoiceconfirm.blade.php
<div>
    <!-- Nothing in life is to be feared, it is only to be understood. Now is the time to understand more, so that we may fear less. - Marie Curie -->
</div>

<x-app-layout>
    <div>
        <h2>Confirmació de factura</h2>
        <p>Nom del client: {{ $client_name }}</p>
        <p>Producte: {{ $product_name }}</p>
        <p>Quantitat: {{ $quantity }}</p>
        <p>Preu unitari: {{ number_format($price, 2) }}</p>
        <p>Percentatge d'IVA: {{ number_format($ivaPercentage, 2) }}%</p>
        <p>IVA: {{ number_format($iva, 2) }}</p>
        <p>Total: {{ number_format($total, 2) }}</p>

        <form method="POST" action="{{ route('invoices.store') }}">
            @csrf
            <input type="hidden" name="client_name" value="{{ $client_name }}">
            <input type="hidden" name="product_name" value="{{ $product_name }}">
            <input type="hidden" name="quantity" value="{{ $quantity }}">
            <input type="hidden" name="price" value="{{ $price }}">
            <input type="hidden" name="ivaPercentage" value="{{ $ivaPercentage }}">
            <input type="hidden" name="iva" value="{{ $iva }}">
            <input type="hidden" name="total" value="{{ $total }}">
            <button type="submit">Confirmar i realitzar compra</button>
        </form>
    </div>
</x-app-layout>

elnombrequetuquieras/resources/views/invoiceinserts.blade.php
<div>
    <!-- Simplicity is an acquired taste. - Katharine Gerould -->
</div>



<x-app-layout>

    <div>
        <a href="{{ route('products') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Productes</a>
        <a href="{{ route('invoices.list') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Comandes</a>

        <h1 style="font-size: 2rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">Emplena el formulari amb els detalls de la teva compra</h1>
    </div>

    <div style="display: flex;
            justify-content: center;">
    <form method="POST" action="{{ route('invoices.confirm') }}">
        @csrf
        <div>
            <label for="client_search">Buscar Cliente:</label>
            <input type="text" id="client_search" placeholder="Buscar Cliente" class="form-control">
            <select id="client_name" name="client_name" class="form-control" required>
                @foreach($clients as $cli)
                    <option value="{{ $cli->client_name }}">{{ $cli->client_name }}</option>
                @endforeach
            </select><br><br>
        </div>
        <div>
            <label for="product_search">Buscar Producto:</label>
            <input type="text" id="product_search" placeholder="Buscar Producto" class="form-control">
            <select id="product_name" name="product_name" class="form-control" required>
                @foreach($products as $pro)
                    <option value="{{ $pro->product_name }}">{{ $pro->product_name }}</option>
                @endforeach
            </select><br><br>
        </div>
        <div>
            <label for="quantity">Quantitat:</label>
            <input type="number" id="quantity" name="quantity" required>
        </div><br>

        <div>
            <label for="password">Password:</label>
            <input type="text" id="password" name="password" required>
        </div><br>

        <div>
            <button type="submit" class="btn btn-primary">Realitzar compra</button>
        </div>
    </form>
    </div>
    <div style="text-align: center;">
        <h1 style="font-size: 1rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">Encara no ets client? Enregistra't a la nostra base de dades aquí mateix!</h1>

        <a href="{{ route('clientinserts') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white; padding: 1rem; border-radius: 0.25rem; display: inline-block">Enregistrar-se</a>

    </div>

    <script>
        document.addEventListener('DOMContentLoaded', function () {
            const clientSearchInput = document.getElementById('client_search');
            const clientSelect = document.getElementById('client_name');
            const productSearchInput = document.getElementById('product_search');
            const productSelect = document.getElementById('product_name');

            clientSearchInput.addEventListener('keyup', function () {
                filterOptions(clientSearchInput.value, clientSelect);
            });

            productSearchInput.addEventListener('keyup', function () {
                filterOptions(productSearchInput.value, productSelect);
            });

            function filterOptions(searchTerm, selectElement) {
                const options = selectElement.querySelectorAll('option');
                options.forEach(option => {
                    if (option.text.toLowerCase().includes(searchTerm.toLowerCase())) {
                        option.style.display = '';
                    } else {
                        option.style.display = 'none';
                    }
                });
            }
        });
    </script>
</x-app-layout>

elnombrequetuquieras/resources/views/invoicesview.blade.php
<div>
    <!-- Live as if you were to die tomorrow. Learn as if you were to live forever. - Mahatma Gandhi -->
</div>


<x-app-layout>
    <div>

        <a href="{{ route('products') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Productes</a>
        <h1 style="font-size: 3rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">INVOICES</h1>

    </div>
<div style="display: flex;
            justify-content: center;">
    <table>
        <thead>
        <tr>
            <th>id</th>
            <th>client_name</th>
            <th>product</th>
            <th>quantity</th>
            <th>price</th>
            <th>IVA_percentage</th>
            <th>IVA</th>
            <th>total</th>
        </tr>
        </thead>

        <body>
        @foreach($invoices as $inv)
            <tr>
                <td>{{$inv->id}}</td>
                <td>{{$inv->client_name}}</td>
                <td>{{$inv->product_name}}</td>
                <td>{{$inv->quantity}}</td>
                <td>{{$inv->price}}</td>
                <td>{{$inv->percentatge_IVA}}</td>
                <td>{{$inv->IVA}}</td>
                <td>{{$inv->total}}</td>
                <td><button type="submit" onclick="location.href='{{url(('/invoices/'.$inv->id.'/delete/'))}}'">Delete</button></td>
            </tr>



        @endforeach



        </body>
    </table>
</div>
    <a href="{{ route('invoices.inserts') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white; padding: 1rem; border-radius: 0.25rem; display: inline-block">Comprar</a>
    <div>

    </div>
</x-app-layout>

elnombrequetuquieras/resources/views/productsview.blade.php
<div>
    <!-- Nothing worth having comes easy. - Theodore Roosevelt -->
    <!-- It is not the man who has too little, but the man who craves more, that is poor. - Seneca -->
</div>

<x-app-layout>
    <div>

        <a href="{{ route('clients') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Clients</a>
        <a href="{{ route('invoices.inserts') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Comprar</a>
        <h1 style="font-size: 3rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">PRODUCTS</h1>
    </div>
    <div style="display: flex;
            justify-content: center;">
<table>
    <thead>
   <tr>
       <th>id</th>
       <th>name</th>
       <th>type</th>
       <th>price</th>
       <th>description</th>
       <th>level</th>
       <th>level required</th>
       <th>stock left</th>
       <th>units sold</th>
       <th>revenue</th>
   </tr>
    </thead>

    <body>
    @foreach($products as $pro)
        <tr>
            <td>{{$pro->id}}</td>
            <td>{{$pro->product_name}}</td>
            <td>{{$pro->product_type}}</td>
            <td>{{$pro->price}}</td>
            <td>{{$pro->description}}</td>
            <td>{{$pro->level}}</td>
            <td>{{$pro->level_required}}</td>
            <td>{{$pro->stock_left}}</td>
            <td>{{$pro->units_sold}}</td>
            <td>{{$pro->revenue}}</td>
            <td><button type="submit" onclick="location.href='{{url(('/products/'.$pro->id.'/delete/'))}}'">Delete</button></td>
            <td><button type="submit" onclick="location.href='{{ route('products.restore', $pro->id) }}'">Restore</button></td>
        </tr>



    @endforeach



    </body>
</table>
        </div>

    <div style="text-align: center;">
        <a href="{{ route('inserts') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white; padding: 1rem; border-radius: 0.25rem; display: inline-block">Insertar Producto</a>
        <a href="{{ route('tops.form') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white;  padding: 1rem; border-radius: 0.25rem; display: inline-block">Rànkings</a>

</div>
</x-app-layout>

elnombrequetuquieras/resources/views/rankings.blade.php
<div>
    <!-- Nothing worth having comes easy. - Theodore Roosevelt -->
</div>


<x-app-layout>
    <a href="{{ route('products') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Productes</a>
    <a href="{{ route('clients') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Clients</a>
    <a href="{{ route('invoices.inserts') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Comprar</a>

    <h1 style="font-size: 3rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">RÀNKINGS</h1>

    <div style="display: flex;
            justify-content: center;">
    <form method="POST" action="{{ route('tops.show') }}">
        @csrf
        <label for="top_type">Selecciona el tipo de top:</label>
        <select id="top_type" name="top_type">
            <option value="top_sold">Top 5 productes més venuts</option>
            <option value="top_revenue">Top 5 productes amb major revenue</option>
            <option value="most_stock">Top 5 productes amb més stock disponible</option>
            <option value="expensive">Top 5 productes amb més cars</option>
            <option value="cheap">Top 5 productes amb més barats</option>
        </select>
        <button type="submit">Consultar Top</button>
    </form>
    </div>


</x-app-layout>

elnombrequetuquieras/resources/views/tops.blade.php
<div>
    <!-- Do what you can, with what you have, where you are. - Theodore Roosevelt -->
</div>


<x-app-layout>
    <a href="{{ route('products') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Productes</a>
    <a href="{{ route('clients') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Clients</a>
    <a href="{{ route('invoices.inserts') }}" class="btn btn-primary" style=" background-color: #1e40af; color: white">Comprar</a>

    <h1 style="font-size: 3rem; color: #1e40af; font-weight: bold;text-align: center;margin-top: 1rem;">RÀNKINGS</h1>

    <div style="display: flex;
            justify-content: center;">
    <form method="POST" action="{{ route('tops.show') }}">
        @csrf
        <label for="top_type">Selecciona el tipo de top:</label>
        <select id="top_type" name="top_type">
            <option value="top_sold">Top 5 productes més venuts</option>
            <option value="top_revenue">Top 5 productes amb major revenue</option>
            <option value="most_stock">Top 5 productes amb més stock disponible</option>
            <option value="expensive">Top 5 productes més cars</option>
            <option value="cheap">Top 5 productes més barats</option>
        </select>
        <button type="submit">Consultar Top</button>
    </form>
    </div>
    <div style="display: flex;flex-direction: column;align-items: center;
            justify-content: center; ">
    @foreach ($topProducts as $product)
        @if ($topType === 'top_sold')
            <p>{{ $product->product_name }} - {{ $product->units_sold }} unitats venudes</p>
        @elseif ($topType === 'top_revenue')
            <p>{{ $product->product_name }} - {{ $product->revenue }} en revenue</p>
        @elseif ($topType === 'most_stock')
            <p>{{ $product->product_name }} - {{ $product->stock_left }} en stock disponible</p>
        @elseif ($topType === 'expensive')
            <p>{{ $product->product_name }} - Preu: {{ $product->price }}</p>
        @elseif ($topType === 'cheap')
            <p>{{ $product->product_name }} - Preu: {{ $product->price }}</p>
        @endif

    @endforeach
    </div>


</x-app-layout>